******************************************************************************
*  CLPHAIKU.prg
*  Copyright 1992 by Ian Thurston, Barrie, Ont. - but (ab)use this as you will
*  Demonstration of a CLIPPER UDF to generate truly horrible random Haiku
*
*  To compile the demo
*        CLIPPER clphaiku
*
*  To link the demo
*        TLINK clphaiku,,,CLIPPER.LIB EXTEND.LIB
*    or  PLINK86 FI clphaiku LIB CLIPPER, EXTEND
*
**** DEMO OF HAIKU() function ************************************************

SETCOLOR( IIF( ISCOLOR(), "W/B,B/W","W/N,N/W"))
@ 1,0 SAY REPLICATE(CHR(176),1840)  && tiling
DO WHILE .T.    && pretty shoddy, I know
SETCOLOR( "N/W,W/N")
@ 0,0 CLEAR TO 0,79
@ 24,0 CLEAR TO 24,79
@ 24,10 say "A Demonstration of HAIKU(), Copyright 1992 by Ian Thurston"
@ 0, 5 PROMPT "Demonstration"
@ 0,25 PROMPT "Source Code"
@ 0,45 PROMPT "Documentation"
@ 0,65 PROMPT "Exit to DOS"
MENU TO h_choice
SETCOLOR( IIF( ISCOLOR(), "W/B,B/W","W/N,N/W"))
SAVE SCREEN TO s_haiku
DO CASE
CASE h_choice = 1   && Do The Demo
    SET CURSOR OFF
    haiku()                             && actual function call
    SET CURSOR ON
CASE h_choice = 2   && check out the program
    DO scanfile WITH "CLPHAIKU.PRG"
    IF yes_no("Do you want to extract the function to a file ?")
        a = memoread("CLPHAIKU.PRG")
        IF MEMOWRIT("CLPHAIKU.FUN",substr(a, AT(CHR(42)+ " Copyright",a)))
            @ 12,20 SAY "Function extracted to file CLPHAIKU.FUN"
        ELSE
            @ 12,10 SAY "Sorry, unable to write to file at this time."
        ENDIF
        INKEY(5)
    ENDIF
CASE h_choice = 3   && read the documentation
    DO scanfile WITH "WHATSUP.DOC"
CASE h_choice = 0 .OR. h_choice = 4     && Exit
    @ 20,10 SAY "Thanks for trying 'HAIKU()' (a.k.a. 'Wrongfellow')"
    INKEY(3)
    QUIT
ENDCASE
RESTORE SCREEN FROM s_haiku
ENDDO

****
PROC scanfile   && Support routine ... HAIKU() is at the bottom
****
PARAMETERS what2scan
PRIVATE a
IF FILE(what2scan)
    PRIVATE s_scanfile, tempcolor
    SAVE SCREEN TO s_scanfile
    @  2 ,15 SAY "Browse ASCII File: Use cursor keys to move, ESC to Exit"
    @  3,0 SAY REPLICATE( CHR(220), 80)
    @ 23,0 SAY REPLICATE( CHR(223), 80)
    tempcolor=SETCOLOR( SUBSTR(SETCOLOR(), AT(",",SETCOLOR())+1))
    a = MEMOREAD(what2scan)
    MEMOEDIT( substr(a, AT(CHR(42)+ " Copyright",a)), 4, 0, 22, 79, .F.)
    RESTORE SCREEN FROM s_scanfile
    SETCOLOR( tempcolor)
    RELEASE s_scanfile, tempcolor
ENDIF
RETURN

****
FUNC yes_no
****
PARAMETERS what2ask
PRIVATE rval, s_yn
s_yn = SAVESCREEN(10,3,14,76)
@ 10,3,14,76 BOX " "
@ 12,5 SAY what2ask
@ ROW(),COL()+2 PROMPT "YES"
@ ROW(),COL()+2 PROMPT "NO"
MENU TO rval
RESTSCREEN(10,3,14,76,s_yn)
RETURN rval = 1

* Here's the meat:


* Copyright 1992 by Ian Thurston, Barrie, Ontario
********
FUNCTION haiku          && generate chaotic haiku
********
*  Calling sequence: [mvar =] haiku()
*
*  Assumes: Nothing
*
*  Examples:
*   HAIKU()                     displays box in centre of screen with
*                               3-line haiku. Waits for key-press
*
*  Keys:
*   any key exits

PRIVATE article, adjective, noun, verb, prep, punc, tempcolor, l, template


* This selects 1 of 4 "templates" to use
l = random(4)

DO CASE
    CASE l = 1
        template = "1_2_3;/1_3_4_5_1_3_/2_3/"
    CASE l = 2
        template = "2_5_1_3;/1_2_3_5_1_3/2_3/"
    CASE l = 3
        template = "1_2_3;/5_1_2_3/1_3_4/"
    CASE l = 4
        template =  "1_2_3_4;/1_2_3/5_1_2_3/"
ENDCASE

*  Explanation of how codes are expanded. You can construct your own
*  templates easily if you wish to experiment.
*  1 = article
*  2 = adjective
*  3 = noun
*  4 = verb
*  5 = preposition
*  ; = punctuation mark
*  / = output current line buffer and drop to new line
*  _ = space



*  these are the word lists used to build the haiku. You can add,
*  subtract, and edit as desired; just remember the comma separator.
*  try replacing the nouns with people's names or tools of your trade
*  for a giggle:  "the cybernetic cardreader bulk erases"

article = ;
"the,a,this,their,the,a,the"

adjective = ;
"autumn,hidden,bitter,misty,silent,empty,dry,dark,summer,icy,delicate,"+;
"quiet,white,cool,spring,winter,dappled,twilight,dawn,crimson,wispy,"+;
"azure,blue,billowing,broken,cold,damp,falling,frosty,green,long,late,"+;
"lingering,limpid,little,morning,muddy,old,red,rough,still,small,"+;
"sparkling,throbbing,saffron,vermillion,wandering,withered,wild,black,"+;
"young,distant,foggy,wet,blackened,snowy,spring,sighing,hidden,ruined,"+;
"stiff,forgotten,drowsy,gleaming,snowy,weeping,desolate,frozen"

noun = ;
"waterfall,river,breeze,moon,rain,wind,sea,morning,snow,lake,sunset,pine,"+;
"shadow,leaf,dawn,glitter,forest,hill,cloud,meadow,sun,glade,bird,brook,"+;
"butterfly,bush,dew,dust,field,fir,flower,firefly,feather,grass,haze,"+;
"mountain,night,pond,shade,snowflake,silence,sound,sky,shape,surf,"+;
"thunder,violet,water,wildflower,wave,garden,shack,bamboo,stone,maple,"+;
"wheelbarrow,sparrow,pathway,pond,leaf,temple,jasmine,statue,pebble,twig,"+;
"petal,cricket,buddha,wisteria"

verb = ;
"appears,disappears,is seen,remains,dissolves,shows,huddles,rises up,"+;
"is still,creaks,sways,is hidden,seems lost,forgets itself,shakes,drifts,"+;
"has stopped,struggles,has fallen,has passed,sleeps,creeps,flutters,"+;
"has risen,is falling,is trickling,murmurs,is floating"

prep = ;
"on,in,under,over,near,by,within,beneath,beside,beyond,alongside"

punc = ;
"...,-,;"

tempcolor=setcolor("W")
@ 9,15,15,64 BOX chr(220)+chr(220)+chr(220)+chr(222)+chr(223)+chr(223) +;
                 chr(223)+chr(221)+" "
@ 15, 25 SAY "  Press any key to move on  "
SETCOLOR("W+")

@ 10, 40 SAY ""
l = ""

FOR a = 1 TO len(template)
    c = substr(template,a,1)
    DO CASE
        CASE c = "1"
            l = l + pick(article)
        CASE c = "2"
            l = l + pick(adjective)
        CASE c = "3"
            l = l + pick(noun)
        CASE c = "4"
            l = l + pick(verb)
        CASE c = "5"
            l = l + pick(prep)
        CASE c = ";"
            l = l + pick(punc)
        CASE c = "_"
            l = l + " "
        CASE c = "/"
            @ ROW()+1, 40 - len(l)/2 SAY l
            l = ""
    ENDCASE
NEXT
INKEY(0)
SETCOLOR(tempcolor)
RELEASE article, adjective, noun, verb, prep, punc, tempcolor, l
RELEASE pattern
RETURN(.T.)


********
FUNCTION pick
********
* picks a word at random from a comma-delimited string of words
PARAMETERS wordlist
PRIVATE n
n = numberof(wordlist,",")+1
RETURN nth(wordlist, random(n))


********
FUNCTION random
********
* pseudo random number generator returns integer between lb and ub
PARAMETERS ub, lb
if PCOUNT() < 2
    lb = 1
endif
if type("temprand")="U"
    public temprand
    temprand =0
endif
DO WHILE temprand<=0
    temprand=VAL(RIGHT(TIME(),2))
ENDDO
temprand=(3.14159*temprand)*(900+VAL(RIGHT(TIME(),2)))
temprand=LOG(temprand)*39
temprand=temprand-INT(temprand)
RETURN INT((ub-lb)*temprand+lb+0.5)


********
FUNCTION nth
********
* returns word at specified position in comma-delimited list of words
PARAMETERS listofwords, wordposition
PRIVATE a, rval, templist
templist = listofwords
FOR a = 1 to IIF(wordposition > 0, wordposition, 1)
rval = parser(@templist, ",")
NEXT
RETURN rval


********
FUNCTION parser
********
* parses a delimited string into components
* (cf S. Straley, Advanced Programming in Clipper with C)
PARA _getstr, _forcode
PRIV _forcode, _location, _tempback
IF PCOUNT() < 2
    _forcode = ";"
ENDIF
_location = AT(_forcode,_getstr)
_tempback = IF(!EMPTY(_location),SUBSTR(_getstr,1,_location -1),_getstr)
_getstr = IF(!EMPTY(_location),SUBSTR(_getstr,_location + 1),"")
RETURN(_tempback)


********
FUNCTION numberof
********
* Return number of occurences of target string within scan string
PARA scanstring, target
IF PCOUNT() < 2
    target = ";"
ENDIF
RETURN LEN(scanstring) - LEN(STRTRAN(scanstring, target))

* END FUNCTION haiku()
